#!/usr/bin/env python
#
# $Id: config.py,v 1.1.1.1 2003/02/11 06:07:42 resolve Exp $
#
# provides configuration loaded on startup and saved on application exit to
# any modules which want it.
#
# Started 14/9/01 by Damien Elmes <resolve@repose.cx>
# This file is licensed under the GPL.
#

import ConfigParser
import os
import atexit

CONFIG_DIR=os.path.expanduser("~/.muse")
CONFIG_FILE=os.path.join(CONFIG_DIR, "rc")

defaults = {}

def write():
    """ write configuration to a file """

    f = open(CONFIG_FILE, "w")
    cparser.write(f)
    f.close()


# config dir not created
if not os.path.isdir(CONFIG_DIR):
    os.mkdir(CONFIG_DIR)

cparser = ConfigParser.ConfigParser()

# load in config, and set ourselves up to write the config data on exit.
cparser.read(CONFIG_FILE)
atexit.register(write)

# if the rc file doesn't exist, load up defaults
if not cparser.has_section("muse"):
    pass

def set_defaults(section, dfaults):
    defaults[section] = dfaults

def get(section, var, default=None):
    """ get var from section, if default is passed, then it will override
    defaults passed by set_defaults """

    try:
        return cparser.get(section, var)
    except:
        if default != None:
            set(section, var, default)
            return default

        else:
            set(section, var, defaults[section][var])
            return defaults[section][var]


def set(section, var, val):
    if not cparser.has_section(section):
        cparser.add_section(section)

    cparser.set(section, var, val)
