#!/usr/bin/env python
#
# $Id: main.py,v 1.1.1.1 2003/02/11 06:07:41 resolve Exp $
#
# Time-stamp: <2003-02-19 22:04:18 resolve>
#
# Copyright (C) Damien Elmes <resolve@repose.cx>, 2001.
# This file is licensed under the GPL. Please see COPYING for more details.
#


"""
Main program entry point for muse
"""

import sys
import os
import getopt

import muse
import ui
import multiplex
import plugins
import fun
import config
import playlist

from debug import debug

import profile
import time

class Muse:

    def __init__(self):
        # some defaults
        self.plugins = []
        self.args = []
        self.opts = []

        self.config_defaults = {
            "plugins": '[]'
            }

    def usage_information(self):
        print  'Usage: ' + sys.argv[0] + ' uri[, uri, ...]' + \
              """
              -p \t specify plugin to load. can be used multiple times."""

    def parse_args(self):
        try:
            self.opts, self.args = getopt.getopt(sys.argv[1:], "p:")
        except getopt.GetoptError:
            self.usage_information()
            return

        for x in self.opts:
            if x[0]=="-p":
                self.plugins.append(x[1])

    def main(self):
        config.set_defaults("main", self.config_defaults)

        self.plugins = eval(config.get("main", "plugins"))
        self.parse_args()

        plugins.add(self.plugins)

        # we don't want to let the user interface take CPU away from the mpg321
        # process.
        #os.system("renice 15 -p %d > /dev/null 2>&1" % os.getpid())

        if self.args:
            for x in self.args:
                muse.plist.add_uri(x)

        ff = playlist.FSCacheFactory()

        debug("Loading cache..")
        thelist = ff.load ("fscache", "/home/resolve/Media/music/mp3s/")

        debug("Saving cache..")
        ff.save("fscache", thelist)

        muse.cache = thelist

            #print "Adding cache to playlist.."
            #muse.plist.add_cache (thelist)

            #print "Done."


        # say hello :-)
        #fun.welcome_message()

        # and then kick into the music
        if len(muse.plist):
            muse.player.start()

        # now launch into the main loop
        multiplex.main_loop()

if __name__ == "__main__":
    app = Muse()

    #profile.run("app.main()", "pstats")
    app.main()


