#!/usr/bin/env python

from debug import *

# modules which support plugins
import ui
import muse

def add(list):
    if type(list) not in (type([]), type(())):
        list = (list,)

    for x in list:
        p = __import__(x).new()

        try:
            debug("adding plugin: " + str(p.plugin_name))
        except AttributeError: # then it's not a valid plugin
            debug("dead plugin: " + repr(p))
            continue



        if p.plugin_type=='ui':
            ui.add_plugin(p)
        elif p.plugin_type=='input':
            muse.player.add_plugin(p)

class new:
    """ plugin framework for muse """

    def __init__(self):
        """ Called on plugin initialisation """
        self.plugin_type = None # one of input, ui
        self.plugin_name = None # short name
        self.plugin_desc = None # description

    def deinit(self):
        """ Called when a plugin is deregistered """
        pass



